//+------------------------------------------------------------------+
//|                                         Auto Fibo_Coodonates.mq4 |
//|                                  Copyright  2009, Julien Loutre |
//|                                         http://www.forexcomm.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2009, Julien Loutre"
#property link      "http://www.forexcomm.com"

#property  indicator_chart_window
#property indicator_buffers  2
#property  indicator_color1  LightSkyBlue
#property  indicator_color2  Plum
 
 
extern string TimeFrame   = "Current time frame"; 
extern int    Band_Period = 48;
extern int    price_type  = 0; // 0 = High/Low | 1 = Open/Close
 
 
//---- buffers
double WWBuffer1[];
double WWBuffer2[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
int    timeFrame;

 
double ATR;
 
int init() {
   IndicatorBuffers(2);

   SetIndexStyle(0,DRAW_LINE,1);
   SetIndexStyle(1,DRAW_LINE,1);
   
   SetIndexLabel(0, "High");
   SetIndexLabel(1, "Low");
   
   SetIndexBuffer(0, WWBuffer1);
   SetIndexBuffer(1, WWBuffer2);
   
   IndicatorDigits(Digits+2);
   
   IndicatorShortName("Automatic Fibonacci");
   
//   ObjectCreate("AutoFibo", OBJ_FIBO, 0, Time[0],High[0],Time[0],Low[0]);
   
    //
    //
    //
    //
    //
   
    indicatorFileName = WindowExpertName();
    returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
    timeFrame         = stringToTimeFrame(TimeFrame);
   
    //
    //
    //
    //
    // 
   
   return(0);
}
int deinit() {
//   ObjectDelete("AutoFibo");
return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { WWBuffer1[0] = limit+1; return(0); }
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);               
                      WWBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Band_Period,price_type,0,y);
                      WWBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Band_Period,price_type,1,y);             
               }
               return(0);
            }

   for(i=limit-1; i>=0; i--) {
 
      WWBuffer1[i] = getPeriodHigh(Band_Period,i);
      WWBuffer2[i] = getPeriodLow(Band_Period,i);
      
//      ObjectSet("AutoFibo", OBJPROP_TIME1, Time[Band_Period]);
//      ObjectSet("AutoFibo", OBJPROP_TIME2, Time[0]);
//      if (Open[Band_Period] > Open[0]) { // Up
//         ObjectSet("AutoFibo", OBJPROP_PRICE1, getPeriodHigh(Band_Period,i));
//         ObjectSet("AutoFibo", OBJPROP_PRICE2, getPeriodLow(Band_Period,i));
//      } else {
//         ObjectSet("AutoFibo", OBJPROP_PRICE1, getPeriodLow(Band_Period,i));
//         ObjectSet("AutoFibo", OBJPROP_PRICE2, getPeriodHigh(Band_Period,i));
//      }
      
   }
   return(0);
}
 
double getPeriodHigh(int period, int pos) {
   int i;
   double buffer = 0;
   for (i=pos;i<=pos+period;i++) {
      if (price_type == 0) {
         if (High[i] > buffer) {
            buffer = High[i];
         }
      } else {
         if (Open[i] > Close[i]) { // Down
            if (Open[i] > buffer) {
               buffer = Open[i];
            }
         } else {
            if (Close[i] > buffer) {
               buffer = Close[i];
            }
         }
      }
   }
   return (buffer);
}
double getPeriodLow(int period, int pos) {
   int i;
   double buffer = 100000;
   for (i=pos;i<=pos+period;i++) {
      if (price_type == 0) {
         if (Low[i] < buffer) {
            buffer = Low[i];
         }
      } else {
         if (Open[i] > Close[i]) { // Down
            if (Close[i] < buffer) {
               buffer = Close[i];
            }
         } else {
            if (Open[i] < buffer) {
               buffer = Open[i];
            }
         }
      }
   }
   return (buffer);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}
